package gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.WindowConstants;


public class ChangePercent extends JDialog implements ActionListener
{
	JButton okeyButton, cancelButton;
	JSpinner ratio;
	boolean changen = true;
	
	/**
	 * Creates a JDialog for changing the percent value of a protein.
	 * @param main main frame, in order to set the JDialog relative to the main window.
	 * @param name name of the protein.
	 * @param type type of the protein, occurs in the title of the JDialog.
	 * @param max_value maxvalue of the protein.
	 * @param min_value	mixvalue of the protein.
	 * @param is_value	current percent value of the protein.
	 */
	public ChangePercent(Main main, String name, String type, int max_value, int min_value, int is_value) {
		this.setTitle("Change percent value for "+type);
		this.setModal(true);
		JTextArea order = new JTextArea("Please choose a new percent value ");
		JTextArea order2 = new JTextArea("for the protein "+name);
		
		order.setBackground(null);
		order.setFocusable(false);
		order.setFont(new Font("Dialog", Font.BOLD ,12));
		order2.setBackground(null);
		order2.setFocusable(false);
		order2.setFont(new Font("Dialog", Font.BOLD ,12));		
		ratio = new JSpinner(new SpinnerNumberModel(is_value, min_value, max_value, min_value));
		okeyButton = new JButton("OK");
		cancelButton = new JButton("Cancel");
		okeyButton.addActionListener(this);
		cancelButton.addActionListener(this);

		//adding the buttons to the bottonbox
		Box buttonbox = new Box(BoxLayout.X_AXIS);
		buttonbox.add(Box.createVerticalStrut(30));
		buttonbox.add(okeyButton);
		buttonbox.add(Box.createVerticalStrut(10));
		buttonbox.add(cancelButton);
		buttonbox.add(Box.createVerticalStrut(30));
		
		
		Container cp = getContentPane();

		Box orderbox = new Box(BoxLayout.X_AXIS);
		orderbox.add(Box.createHorizontalStrut(20));
		orderbox.add(order);
		orderbox.add(Box.createHorizontalStrut(5));	

		Box orderbox2 = new Box(BoxLayout.X_AXIS);
		orderbox2.add(Box.createHorizontalStrut(20));
		orderbox2.add(order2);
		orderbox2.add(Box.createHorizontalStrut(5));	
		
		Box ratiobox = new Box(BoxLayout.X_AXIS);
		ratiobox.add(Box.createHorizontalStrut(100));
		ratiobox.add(ratio);
		ratiobox.add(Box.createHorizontalStrut(130));	
		
		
		Box proteinbox = new Box(BoxLayout.Y_AXIS);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(orderbox);
		
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(orderbox2);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(ratiobox);
		proteinbox.add(Box.createVerticalStrut(20));
		proteinbox.add(buttonbox);
		proteinbox.add(Box.createVerticalStrut(20));	
		
		cp.add(proteinbox);
		this.setSize(270,200);	   
		this.setFocusable(true);
		this.setLocationRelativeTo(main);
	    this.setDefaultCloseOperation(
	                WindowConstants.DISPOSE_ON_CLOSE);
	    this.setVisible(true);  
	    this.setResizable(false);
	}

	/**
	 * Creates a JDialog for changing the percent value of a protein when the protein size was too small.
	 * @param main main frame, in order to set the JDialog relative to the main window.
	 * @param name name of the protein.
	 * @param type type of the protein, occurs in the title of the JDialog.
	 * @param max_value maxvalue of the protein.
	 * @param min_value	mixvalue of the protein.
	 * @param is_value	current percent value of the protein.
	 * @param flag whether the JDialog should occur after the value for the protein was to small (if the flag is 1 there is an additional information to change the percent value because of the futher small value).
	 */
	
	public ChangePercent(Main main, String name, String type, int max_value, int min_value, int is_value, int flag) {
		this.setTitle("Change percent value for "+type);
		this.setModal(true);
JTextArea description = new JTextArea("The value is to small.");
		JTextArea order = new JTextArea("Please choose a new percent value for the");
		JTextArea order2 = new JTextArea("protein "+name);
		
		description.setBackground(null);
		description.setFocusable(false);
		description.setFont(new Font("Dialog", Font.BOLD ,12));
		order.setBackground(null);
		order.setFocusable(false);
		order.setFont(new Font("Dialog", Font.BOLD ,12));
		order2.setBackground(null);
		order2.setFocusable(false);
		order2.setFont(new Font("Dialog", Font.BOLD ,12));		
		ratio = new JSpinner(new SpinnerNumberModel(is_value, min_value, max_value, min_value));
		okeyButton = new JButton("OK");
		cancelButton = new JButton("Cancel");
		okeyButton.addActionListener(this);
		cancelButton.addActionListener(this);

		//adding the buttons to the bottonbox
		Box buttonbox = new Box(BoxLayout.X_AXIS);
		buttonbox.add(Box.createVerticalStrut(30));
		buttonbox.add(okeyButton);
		buttonbox.add(Box.createVerticalStrut(10));
		buttonbox.add(cancelButton);
		buttonbox.add(Box.createVerticalStrut(30));
		
		
		Container cp = getContentPane();
		
		Box orderbox = new Box(BoxLayout.X_AXIS);
		orderbox.add(Box.createHorizontalStrut(20));
		orderbox.add(order);
		orderbox.add(Box.createHorizontalStrut(5));	

		Box descriptionbox = new Box(BoxLayout.X_AXIS);
		descriptionbox.add(Box.createHorizontalStrut(20));
		descriptionbox.add(description);
		descriptionbox.add(Box.createHorizontalStrut(5));	

		Box orderbox2 = new Box(BoxLayout.X_AXIS);
		orderbox2.add(Box.createHorizontalStrut(20));
		orderbox2.add(order2);
		orderbox2.add(Box.createHorizontalStrut(5));	
		
		Box ratiobox = new Box(BoxLayout.X_AXIS);
		ratiobox.add(Box.createHorizontalStrut(100));
		ratiobox.add(ratio);
		ratiobox.add(Box.createHorizontalStrut(130));	
		
		
		Box proteinbox = new Box(BoxLayout.Y_AXIS);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(descriptionbox);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(orderbox);		
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(orderbox2);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(ratiobox);
		proteinbox.add(Box.createVerticalStrut(20));
		proteinbox.add(buttonbox);
		proteinbox.add(Box.createVerticalStrut(20));	
		
		cp.add(proteinbox);
		this.setSize(300,200);	   
		this.setFocusable(true);
		this.setLocationRelativeTo(main);
	    this.setDefaultCloseOperation(
	                WindowConstants.DISPOSE_ON_CLOSE);
	    this.setVisible(true);  
	    this.setResizable(false);
	}
	
	/**
	 * Performs the action events for the JDialog (mainly the ok and cancel button).
	 * 	 
	 * @param e ActionEvent
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == (okeyButton)) {
			changen = true; 
			this.dispose();
			return;
		}
		if(e.getSource() == (cancelButton)){
			changen = false;
			this.dispose();
			
			return;
		}
		
	}
/** Returns the new selected ratio value for the protein.
 *  @return Returns the new ratio. 
 */
	public String getRatio(){
		return ratio.getValue().toString();
	}

	/**
	 * Returns the return value of the JDialog.
	 * @return if the ratio value should be changed
	 * 	   true: if okey button was clicked
	 * 	   false: if the changing process was cancelled 
	 */
	public boolean getChangen(){
		return changen;
	}
}