/**
 * CVS-informations
 * 
 * $Author: robert $
 * $Date: 2006/04/02 19:05:36 $
 * $Revision: 1.2 $
 * 
 */
package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.util.HashMap;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import msg.ProteinElement;
import msg.ProteinMatrix;

/**
 * @author rob
 * 
 */
public class CopyOfMsg_panel extends JPanel implements ActionListener {

	JScrollPane scroll;
	JPanel panel;
	
	int mHeight = 50;

	int mWidth = 60;

	int mZoom = 0;

	int mZoomFactor = 10; // in percent

	int pWidth;
	int pHeight;
	int mOffsetX, mOffsetY;

	int proteinElementNumber = 0;

	ProteinMatrix proteinMatrix;

	ProteinElement clickedProtein;

	boolean clickedProteinSet = false;

	Vector vectorE = new Vector();

	Vector proteins = new Vector();

	JButton generateNew, rotateProtein, blub, zoomIn, zoomOut;

	String generateNewText = " Generate New ";

	String rotateProteinText = "Rotate Protein";

	String blubText = "         blub         ";

	String zoomInText = "     Zoom in     ";

	String zoomOutText = "     Zoom out    ";

	public CopyOfMsg_panel() {

		createTestVector();
		setProteinElementNumber_();
		
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;

		this.setLayout(gbl);

		gbc = makegbc(0, 0, 6, 1);
		gbc.weightx = mWidth;
		gbc.weighty = mHeight;
		gbc.fill = GridBagConstraints.BOTH;
		panel = new JPanel(new BorderLayout());		
		panel.setBackground(Color.BLACK);
		panel.setSize(700,400-10);
		pWidth = panel.getWidth();
		pHeight= panel.getHeight();
		panel.addComponentListener(new ComponentListener() {
			public void componentHidden(ComponentEvent arg0) {
			}

			public void componentShown(ComponentEvent arg0) {
			}

			public void componentMoved(ComponentEvent arg0) {
			}

			public void componentResized(ComponentEvent arg0) {
				//proteinMatrix.changeResize();
			}
		});
//		proteinMatrix = new ProteinMatrix(this, panel.getWidth(), panel.getHeight());
		scroll = new JScrollPane();
		scroll.setViewportView(proteinMatrix);
		scroll.setPreferredSize(new Dimension(panel.getWidth(), panel.getHeight()));
		panel.add(scroll, BorderLayout.CENTER);
		gbl.setConstraints(panel, gbc);
		this.add(panel);

		gbc = makegbc(0, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		generateNew = new JButton(generateNewText);
		generateNew.setBackground(Color.black);
		generateNew.setForeground(Color.white);
		generateNew.setBorderPainted(false);
		generateNew.addActionListener(this);
		gbl.setConstraints(generateNew, gbc);
		this.add(generateNew);

		gbc = makegbc(2, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		rotateProtein = new JButton(rotateProteinText);
		rotateProtein.setBackground(Color.black);
		rotateProtein.setForeground(Color.white);
		rotateProtein.setBorderPainted(false);
		rotateProtein.addActionListener(this);
		gbl.setConstraints(rotateProtein, gbc);
		this.add(rotateProtein);

		gbc = makegbc(5, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		blub = new JButton(blubText);
		blub.setBackground(Color.black);
		blub.setForeground(Color.white);
		blub.setBorderPainted(false);
		blub.addActionListener(this);
		gbl.setConstraints(blub, gbc);
		this.add(blub);

		gbc = makegbc(3, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		zoomIn = new JButton(zoomInText);
		zoomIn.setBackground(Color.black);
		zoomIn.setForeground(Color.white);
		zoomIn.setBorderPainted(false);
		zoomIn.addActionListener(this);
		gbl.setConstraints(zoomIn, gbc);
		this.add(zoomIn);

		gbc = makegbc(4, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		zoomOut = new JButton(zoomOutText);
		zoomOut.setBackground(Color.black);
		zoomOut.setForeground(Color.white);
		zoomOut.setBorderPainted(false);
		zoomOut.addActionListener(this);
		gbl.setConstraints(zoomOut, gbc);
		this.add(zoomOut);
	}

	private GridBagConstraints makegbc(int x, int y, int width, int height) {
		// neue Instanz erzeugen
		GridBagConstraints gbc = new GridBagConstraints();
		// Werte festlegen, die als Parameter uebergeben wurden
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.insets = new Insets(0, 0, 0, 0);
		// Werte/Eigenschaften zurueckgeben
		return gbc;
	}

	public void addProteinToVector(ProteinElement neuer) {
		vectorE.addElement(neuer);
	}

	public ProteinElement getProteinFromVector(int index) {
		return (ProteinElement) vectorE.get(index);
	}

	public void createTestVector() {
		HashMap tmp;

		tmp = new HashMap();
		tmp.put("id", "id1");
		tmp.put("label", "l1_");
		tmp.put("sizeX", new Integer(5));
		tmp.put("sizeY", new Integer(5));
		tmp.put("quantity", new Integer(5));
		tmp.put("color", new Color(96, 209, 77));
		proteins.addElement(tmp);

		tmp = new HashMap();
		tmp.put("id", "id2");
		tmp.put("label", "l2_");
		tmp.put("sizeX", new Integer(8));
		tmp.put("sizeY", new Integer(8));
		tmp.put("quantity", new Integer(2));
		tmp.put("color", new Color(165, 78, 46));
		proteins.addElement(tmp);

		tmp = new HashMap();
		tmp.put("id", "id3");
		tmp.put("label", "l3_");
		tmp.put("sizeX", new Integer(6));
		tmp.put("sizeY", new Integer(4));
		tmp.put("quantity", new Integer(3));
		tmp.put("color", new Color(202, 189, 251));
		proteins.addElement(tmp);
	}

	public void setProteinElementNumber_() {
		for (int i = 0; i < proteins.size(); i++) {
			proteinElementNumber += ((Integer) ((HashMap) proteins.get(i))
					.get("quantity")).intValue();
		}
	}

	public void actionPerformed(ActionEvent event) {
		String cmd = event.getActionCommand();

		if (cmd.equals(generateNewText)) {
			deleteAll();
			proteinMatrix.generateNew();
		}

		if (cmd.equals(rotateProteinText)) {
			if (!clickedProteinSet || !clickedProtein.rotateProteinElement()) {
				System.out.println("ERROR: rotate not possible !");
			} else {
				System.out.println("rotate done");
			}
		}

		if (cmd.equals(blubText)) {
			System.out.println("## B L U B ##");
		}

		if (cmd.equals(zoomInText)) {
			int pWidthOld = pWidth;
			int pHeightOld = pHeight;
			pWidth += (int) (pWidth * mZoomFactor / 100);
			pWidth = (int) (pWidth / mWidth) * mWidth;
			pHeight += (int) (pHeight * mZoomFactor / 100);
			pHeight = (int) (pHeight / mHeight) * mHeight;
			if ((pWidthOld / mWidth) == pWidth / mWidth) {
				pWidth = ((int) pWidth / mWidth + 1) * mWidth;
				pHeight = ((int) pHeight / mHeight + 1) * mHeight;
			}
			mZoom += (int) (pWidth / mWidth) - (int) (pWidthOld / mWidth);
			System.out.println("ZOOM IN: " + mZoom);
			mOffsetX = ((this.proteinMatrix.getWidth() - pWidth-1) < 0) ? 0 : (int) (this.proteinMatrix.getWidth() - pWidth-1) / 2;
			mOffsetY = ((this.panel.getHeight() - pHeight) < 0) ? 0 : (int) (this.panel.getHeight() - pHeight) / 2;
			proteinMatrix.generateMatrix(pWidth, pHeight);
			proteinMatrix.changeElements();
			proteinMatrix.repaint();
			proteinMatrix.revalidate();
		}

		if (cmd.equals(zoomOutText)) {
			if ((int)(this.pWidth/this.mWidth) > 1) {
				int pWidthOld = pWidth;
				int pHeightOld = pHeight;
				pWidth -= (int) (pWidth * mZoomFactor / 100);
				pWidth = (int) (pWidth / mWidth) * mWidth;
				pHeight -= (int) (pHeight * mZoomFactor / 100);
				pHeight = (int) (pHeight / mHeight) * mHeight;
				if ((pWidthOld / mWidth) == pWidth / mWidth) {
					pWidth = ((int) pWidth / mWidth - 1) * mWidth;
					pHeight = ((int) pHeight / mHeight - 1) * mHeight;
				}
				mZoom += (int) (pWidth / mWidth) - (int) (pWidthOld / mWidth);
				System.out.println("ZOOM OUT: " + mZoom);
				System.out.println("ZOOM OUT: " + this.panel.getHeight() + " - " + this.pHeight+" - "+this.getHeight());
				mOffsetX = (this.proteinMatrix.getWidth() < this.pWidth-1) ? 0 : (int)((this.proteinMatrix.getWidth()-this.pWidth-1) / 2);
				mOffsetY = (this.panel.getHeight() < this.pHeight) ? 0 : (int)((this.panel.getHeight()-this.pHeight) / 2);
				System.out.println("moffsety: "+mOffsetY);
				proteinMatrix.generateMatrix(this.pWidth, this.pHeight);
				proteinMatrix.changeElements();
				proteinMatrix.repaint();
				proteinMatrix.revalidate();
			}
		}
	}
	
	
	public void deleteAll() {
		getVectorE().removeAllElements();
		proteinMatrix.removeAll();
		proteinMatrix.clearCords();
	}

	public int[] calculateMatrixStartSize(int panelWidth, int panelHeight,
			int matrixWidth, int matrixHeight) {
		int[] matrixStartSize = new int[2];

		double panelRatio = (double) panelWidth / (double) panelHeight;
		double matrixRatio = (double) matrixWidth / (double) matrixHeight;

		if (panelRatio < 1) {
			if ((matrixRatio < 1) && (matrixRatio < panelRatio)) {
				// hhe
				matrixStartSize[1] = panelHeight;
				matrixStartSize[0] = (int) ((double) panelHeight * matrixRatio);
				// System.out.println("1");
			} else {
				// breite
				matrixStartSize[0] = panelWidth;
				matrixStartSize[1] = (int) ((double) panelWidth / matrixRatio);
				// System.out.println("2");
			}
		} else {
			if ((matrixRatio > 1) && (matrixRatio > panelRatio)) {
				// breite
				matrixStartSize[0] = panelWidth;
				matrixStartSize[1] = (int) ((double) panelWidth / matrixRatio);
				// System.out.println("3");
			} else {
				// hhe
				matrixStartSize[1] = panelHeight;
				matrixStartSize[0] = (int) ((double) panelHeight * matrixRatio);
				// System.out.println("4");
			}
		}
		System.out.println("old W: " + panelWidth + " - old H: " + panelHeight);
		System.out.println("new W: " + matrixStartSize[0] + " - new H: "
				+ matrixStartSize[1]);
		matrixStartSize[0] = (matrixStartSize[0] / mWidth) * mWidth;
		matrixStartSize[1] = (matrixStartSize[1] / mHeight) * mHeight;
		pWidth = matrixStartSize[0];
		pHeight = matrixStartSize[1];
		mOffsetX = (int) (panelWidth - pWidth) / 2;
		mOffsetY = (int) (panelHeight - pHeight) / 2;
		System.out.println(panelHeight - pHeight);
		return matrixStartSize;
	}

	public int getMHeight() {
		return mHeight;
	}

	public void setMHeight(int height) {
		mHeight = height;
	}

	public int getMWidth() {
		return mWidth;
	}

	public void setMWidth(int width) {
		mWidth = width;
	}

	public Vector getProteins() {
		return proteins;
	}

	public void setProteins(Vector proteins) {
		this.proteins = proteins;
	}

	public Vector getVectorE() {
		return vectorE;
	}

	public ProteinElement getClickedProtein() {
		return clickedProtein;
	}

	public void setClickedProtein(ProteinElement clickedProtein) {
		this.clickedProtein = clickedProtein;
	}

	public boolean isClickedProteinSet() {
		return clickedProteinSet;
	}

	public void setClickedProteinSet(boolean clickedProteinSet) {
		this.clickedProteinSet = clickedProteinSet;
	}

	public int getProteinElementNumber() {
		return proteinElementNumber;
	}

	public void setProteinElementNumber(int proteinElementNumber) {
		this.proteinElementNumber = proteinElementNumber;
	}

	public int getMOffsetX() {
		return mOffsetX;
	}

	public void setMOffsetX(int offsetX) {
		mOffsetX = offsetX;
	}

	public int getMOffsetY() {
		return mOffsetY;
	}

	public void setMOffsetY(int offsetY) {
		mOffsetY = offsetY;
	}

	/**
	 * @return Returns the mZoom.
	 */
	public int getMZoom() {
		return mZoom;
	}

	/**
	 * @param zoom The mZoom to set.
	 */
	public void setMZoom(int zoom) {
		mZoom = zoom;
	}
}
