package gui;

import gui.messages.ErrorMessage;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyVetoException;
import java.beans.VetoableChangeListener;
import java.security.acl.Owner;

import javax.swing.*;


public class CreateKomponent extends JDialog implements ActionListener {
	JButton okey, cancel;

	JTextField kategoryName, proteinName;

	JSpinner proteinRatio;

	boolean moven = true;
	
	int type; 
	/**
	 * Creates JDialog in order to enter some information about new component/protein. 
	 * @param main main frame, in order to set the JDialog relative to the main window.
	 * @param name name of the new component/protein.
	 * @param type if the new object is a component or protein (0 for component, 1 for protein).
	 * @param komp number of components in the membrane model tree (default for protein: 0).
	 * @param max maximal percent value for protein.
	 */
	
	/*
	 * type: 0 => create new komponte
	 * 		 1 => create new protein
	 */
	
	
	public CreateKomponent(Main main, String name, int type, int komp, int max) {
		this.setModal(true);
		JTextArea proteinnameOrder = new JTextArea("     Please enter a new proteinname");
		JTextArea proteinratioOrder = new JTextArea("     Please select the ratio protein - lipids");
		
		proteinnameOrder.setBackground(null);
		proteinnameOrder.setFocusable(false);
		proteinnameOrder.setFont(new Font("Dialog", Font.BOLD ,12));
		
		proteinratioOrder.setBackground(null);
		proteinratioOrder.setFocusable(false);
		proteinratioOrder.setFont(new Font("Dialog", Font.BOLD ,12));
		
		proteinName = new JTextField(1);
		proteinName.setBorder(BorderFactory.createTitledBorder(""));
		proteinName.setText(name);
		
		Box proteinNamebox = new Box(BoxLayout.X_AXIS);
		proteinNamebox.add(Box.createHorizontalStrut(15));
		proteinNamebox.add(proteinName);
		proteinNamebox.add(Box.createHorizontalStrut(15));
		proteinRatio = new JSpinner(new SpinnerNumberModel(1, 1, max,1));
		Box proteinratiobox = new Box(BoxLayout.X_AXIS);
		proteinratiobox.add(Box.createHorizontalStrut(100));
		proteinratiobox.add(proteinRatio);
		proteinratiobox.add(Box.createHorizontalStrut(130));	
		
		
		Box proteinbox = new Box(BoxLayout.Y_AXIS);
		proteinbox.add(proteinnameOrder);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(proteinNamebox);
		proteinbox.add(Box.createVerticalStrut(20));
		proteinbox.add(proteinratioOrder);
		proteinbox.add(Box.createVerticalStrut(5));
		proteinbox.add(proteinratiobox);		
		proteinbox.add(Box.createVerticalStrut(20));
		
		okey = new JButton("OK");
		cancel = new JButton("Cancel");
		okey.addActionListener(this);
		cancel.addActionListener(this);
		
		//adding the buttons to the bottonbox
		Box buttonbox = new Box(BoxLayout.X_AXIS);
		buttonbox.add(Box.createVerticalStrut(30));
		buttonbox.add(okey);
		buttonbox.add(Box.createVerticalStrut(10));
		buttonbox.add(cancel);
		buttonbox.add(Box.createVerticalStrut(30));
		
		
		if(type == 0){
			this.setTitle("Add new component");			
			// JTextArea with description/order for the input
			JTextArea kategorynameOrder = new JTextArea("     Please enter a new componentname");
			JTextArea kategoryratioOrder = new JTextArea("     Please select ratio component - lipids");

			kategorynameOrder.setBackground(null);
			kategorynameOrder.setFocusable(false);
			kategorynameOrder.setFont(new Font("Dialog", Font.BOLD ,12));
			
			kategoryratioOrder.setBackground(null);
			kategoryratioOrder.setFocusable(false);
			kategoryratioOrder.setFont(new Font("Dialog", Font.BOLD ,12));

			
			// TextFields for the input of kategoryName/proteinName
			kategoryName = new JTextField(1);
			kategoryName.setBorder(BorderFactory.createTitledBorder(""));
			kategoryName.setText("Component-"+komp);			

			
			//Boxes
			Box kategoryNamebox = new Box(BoxLayout.X_AXIS);
			kategoryNamebox.add(Box.createHorizontalStrut(15));
			kategoryNamebox.add(kategoryName);
			kategoryNamebox.add(Box.createHorizontalStrut(15));

			Box kategorybox = new Box(BoxLayout.Y_AXIS);
			kategorybox.add(Box.createVerticalStrut(20));
			kategorybox.add(kategorynameOrder);
			kategorybox.add(Box.createVerticalStrut(5));
			kategorybox.add(kategoryNamebox);
			kategorybox.add(Box.createVerticalStrut(30));
			kategorybox.setBorder(BorderFactory.createTitledBorder(""));
			
			
			//adding the components to box
			Box areabox = new Box(BoxLayout.Y_AXIS);
			//areabox.add(Box.createVerticalStrut(30));			
			areabox.add(kategorybox);
			areabox.add(Box.createVerticalStrut(30));
			areabox.add(proteinbox);

			//adding the topbox and the bottumbox to the mainbox
			Box mainbox = new Box(BoxLayout.Y_AXIS);
			mainbox.add(areabox);
			mainbox.add(buttonbox);
			mainbox.add(Box.createVerticalStrut(20));
			kategoryName.requestFocus(true);
			getContentPane().add(mainbox);
			this.setSize(250, 350);
			
		}

		
		if (type == 1) {
			Box areabox = new Box(BoxLayout.Y_AXIS);
			//areabox.add(Box.createVerticalStrut(30));			
			areabox.add(Box.createVerticalStrut(20));
			areabox.add(proteinbox);

			//adding the topbox and the bottumbox to the mainbox
			Box mainbox = new Box(BoxLayout.Y_AXIS);
			mainbox.add(areabox);
			mainbox.add(buttonbox);
			mainbox.add(Box.createVerticalStrut(20));
			proteinName.requestFocus(true);
			getContentPane().add(mainbox);
		
			this.setSize(250, 220);
			this.setTitle("Add new protein");

		}

		this.setFocusable(true);
		this.setLocationRelativeTo(main);
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setVisible(true);
		this.setResizable(false);

	}

		
	/**
	 * Performs the action events for the JDialog (mainly the ok and cancel button).
	 * 	 
	 * @param e ActionEvent
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == (okey)) {
/*
			if(type == 0){
				if (kategoryName.getText().equals("")) {
					ErrorMessage error = new ErrorMessage(
					"Please enter a Component Name!");
				} else
				this.dispose();

			}
			*/
			if (proteinName.getText().equals("")) {
				ErrorMessage error = new ErrorMessage("Please enter a Protein Name!");
			} else
			this.dispose();
			moven = true;
			return;
		}
		if (e.getSource() == (cancel)) {
			this.dispose();
			moven = false;
			return;
		}

	}
	
	/**
	 * Returns the kategory name entered in the JDialog.
	 * @return Returns the kategory name.
	 */
	public String getKatName() {
		return (kategoryName.getText());
	}

	/**
	 * Returns the protein name entered in the JDialog.
	 * @return Returns the protein name.
	 */
	public String getName() {
		return (proteinName.getText());
	}

	/**
	 * Returns the protein ratio for the new protein.
	 * @return Returns the protein ratio.
	 */
	public int getRatio() {
		return Integer.parseInt(proteinRatio.getValue().toString());
	}

	/**
	 * Returns the return value of the JDialog.
	 * @return which button was klicked.
	 * 		true: okey button
	 * 		false: cancel button
	 */	
	public boolean getMoven() {
		return moven;
	}
}