/**
 * CVS-informations
 * 
 * $Author: bsommer $
 * $Date: 2006/07/05 15:05:34 $
 * $Revision: 1.6 $
 * 
 */
package gui;

import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 * 
 * This class contains the credits of the program and is invoked, when the user
 * clicks on the MainMenu Help->Credits
 */
public class Credits extends JDialog implements ActionListener {

	public JTextField description, name;

	public boolean returnValue;

	/**
	 * Initializes and shows the Credits screen. It gets the main in order to
	 * set its own position in relation to the main-JFrame. It contains a
	 * textarea with the Introduction-text, the "OK"-button to close the window
	 * and the "Help"-button to initialize the Help-window.
	 * 
	 * @param main
	 *            Main
	 */
	public Credits(Main main) {
		this.setTitle("Credits Cm MembraneEditor");

		this.requestFocus(true);
		this.setSize(350, 600);
		this.setLocationRelativeTo(main);

		// the credit-text
		JTextArea intro = new JTextArea(1, 1);
		intro.setBackground(null);
		intro.setFocusable(false);
		intro.setFont(new Font("Dialog", Font.BOLD, 12));
		intro.setBorder(BorderFactory.createTitledBorder(""));
		intro.setText("CELLmicrocomos II: CellmembraneVisualization\n"
				+ "\nProjectLeader:\n" + "Dieter Lorenz (4)\n"
				+ "\nJmol-Integration/Visualization:\n" + "Jan Pieniak (7)\n"
				+ "Bjrn Sommer (2)\n" + "\nGui:\n" + "Martha Zakrzewski (3)\n"
				+ "\nPDB/XML-Integration:\n" + "Sebastian Janowski (6)\n"
				+ "Dominik Mertens(5)\n" + "Robert Schmieder (1)\n"
				+ "\nThis program contains the Jmol-package:\n"
				+ "http://jmol.sourceforge.net\n"
				+ "\n(C) 2006 University of Bielefeld");

		Box introbox = new Box(BoxLayout.X_AXIS);
		introbox.add(Box.createHorizontalStrut(15));
		introbox.add(intro);
		//introbox.add(Box.createHorizontalStrut(15));

		// the crew-image
		Image imageCrew = Toolkit.getDefaultToolkit().getImage("images/Cm2_crew.jpg");
		ImageIcon iconCrew = new ImageIcon(imageCrew);
		JLabel labelCrew = new JLabel(iconCrew);
		Box labelbox = new Box(BoxLayout.X_AXIS);
		labelCrew.setBorder(BorderFactory.createTitledBorder(""));
		labelbox.add(Box.createHorizontalStrut(15));
		labelbox.add(labelCrew);
		labelbox.add(Box.createHorizontalStrut(15));
		
		JButton okey = new JButton("OK");
		JButton help = new JButton("Help");
		okey.addActionListener(this);
		help.addActionListener(this);

		// adding the buttons to the bottonbox
		Box buttonbox = new Box(BoxLayout.X_AXIS);
		buttonbox.add(Box.createVerticalStrut(30));
		buttonbox.add(okey);
		// buttonbox.add(Box.createVerticalStrut(20));
		// help disabled here: buttonbox.add(help);
		buttonbox.add(Box.createVerticalStrut(30));

		// adding the topbox and the bottumbox to the mainbox
		Box mainbox = new Box(BoxLayout.Y_AXIS);
		mainbox.add(Box.createVerticalStrut(10));
		mainbox.add(introbox);
		mainbox.add(Box.createVerticalStrut(10));
		mainbox.add(labelbox);
		mainbox.add(Box.createVerticalStrut(5));
		mainbox.add(buttonbox);
		mainbox.add(Box.createVerticalStrut(5));
		getContentPane().add(mainbox);

		show();

	}

	/**
	 * The action which is performed when the user is clicking on the "OK" or
	 * "Help" Buttons.
	 * 
	 * @param arg0
	 *            ActionEvent
	 */
	public void actionPerformed(ActionEvent arg0) {
		String actionCommand = arg0.getActionCommand();
		if (actionCommand.equals("OK")) {
			returnValue = true;
			dispose();

		}
		if (actionCommand.equals("Help")) {
			returnValue = false;
			HelpPanel help = new HelpPanel();
			dispose();
		}
	}

	/**
	 * Returns the value of the actionPerformed function.
	 * 
	 * @return returnValue boolean
	 */
	public boolean getReturnValue() {
		return returnValue;
	}

}
