package gui;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeModel;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

public class DBSave {
	public Document doc;
	
	public DBSave(){
	
	}
	/**
	 * Write a xml file from consisting the pdb files in the database tree.
	 * @param f file to write and save.
	 * @param tree JTree with PDBs to save.
	 */
	public void writeDB(File f, JTree tree){
		TreeModel tm = tree.getModel();
		DefaultMutableTreeNode rootTree = (DefaultMutableTreeNode) tm.getRoot();
		doc = new Document(new Element(rootTree.toString()));
		Element rootXML = doc.getRootElement();
		Element pdb_xml;
		for(int i=0; i<rootTree.getChildCount();i++){
				DefaultMutableTreeNodeFile pdbFile = (DefaultMutableTreeNodeFile)rootTree.getChildAt(i);
				String filePDB = pdbFile.getFile().toString();
				String namePDB = pdbFile.getName();
				pdb_xml = new Element("PDB");
				pdb_xml.setAttribute("name", namePDB);
				pdb_xml.setAttribute("file", filePDB);
				rootXML.addContent(pdb_xml);
		}		


		XMLwrite(f, doc);
	}

	private void XMLwrite(File f, Document doc) {

		XMLOutputter outputter = new XMLOutputter();
		outputter.setFormat(Format.getPrettyFormat());
		String file = f.toString();

		if (!file.endsWith(".xml")) {
			file = file + ".xml";
			f = new File(file);
		}

		try {
			outputter.output(doc, new BufferedWriter(new FileWriter(f)));
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
	
	
	
	
	
	

