package gui;

import java.io.File;
import java.util.List;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

public class DBload {
	public DBload(){}
	
	/**
	 * Constructs a JTree of a given xml file.
	 * @param f  file to parse.
	 * @return	JTree with parsed pdbs as DefaultMutableTreeNodeFile.
	 */
	public JTree loadFromFile(File f)  {
		JTree tree = new JTree();
		try	{
			Document doc = new SAXBuilder().build(f);
			Element root = doc.getRootElement();
			List pdbs = root.getChildren();
			DefaultMutableTreeNode rootTree = new DefaultMutableTreeNode(root.getName());
			for(int i=0; i<pdbs.size(); i++){
				String pdbName = ((Element)pdbs.get(i)).getAttribute("name").getValue();
			    String pdbFile = ((Element)pdbs.get(i)).getAttribute("file").getValue();
				rootTree.add(new DefaultMutableTreeNodeFile(pdbName,pdbFile ));
			}

			DefaultTreeModel model = new DefaultTreeModel(rootTree);
			tree = new JTree(model);
			tree.setRootVisible(true);
		}
		catch(Exception e) {
			//e.printStackTrace();
			System.out.println(e);
		}
		TreeModel tm = tree.getModel();
		DefaultMutableTreeNode root = (DefaultMutableTreeNode) tm.getRoot();
		return tree;
	}

	
}
		
		
