package gui;

import java.io.File;

import javax.swing.filechooser.FileSystemView;
 
public class DatabaseSystemView extends FileSystemView
{
	File root;
	File[] roots = new File[1];
	File parent;
 /**
  * Extends the FileSystemView (disables navigation through directories)
  * @param root File
  */
	public DatabaseSystemView(File root)
	{
		super();
		this.root = root;
		roots[0] = root;
		try {
			File f = root.getCanonicalFile();
			parent = root.getParentFile();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
 /**
  * Returns the parent directory
  * @param dir File
  * @return Returns the file
  */
	public File getParentDirectory(File dir) {
		File d = null;

		try {
			if (dir.getCanonicalFile().equals(root.getCanonicalFile())) {
				d = dir;
			} else {
				d = super.getParentDirectory(dir);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return d;
	}
/**
 * Enables the possibility for creating a new folder
 * @param containingDir File
 * @return File
 */
	public File createNewFolder(File containingDir)
	{
		File folder = new File(containingDir, "New Folder");
		
		folder.mkdir();
		return folder;
	}

	public File getDefaultDirectory()
	{
		return root;
	}
 
	public File getHomeDirectory()
	{
		return root;
	}
 
	public File[] getRoots()
	{
		return roots;
	}
 

}

