package gui;

import java.io.File;

import javax.swing.tree.DefaultMutableTreeNode;

import protein.Protein;
/*class for the pdb leafs in the database*/

public class DefaultMutableTreeNodeFile 
	extends DefaultMutableTreeNode {
		public String file;

		public String pdbname;

		public Protein protein;
		
		/**
		 * Constructs a node object for the pdb tree.
		 * @param pdbname the pdb code of the pdb file.
		 * @param file	relative file path of the pdb file.
		 */
		public DefaultMutableTreeNodeFile(String pdbname, String file){
			this.file = file; 
			this.pdbname = pdbname;
			this.setUserObject(pdbname);
			
		}
		
		/**
		 * Returns the filepath of the pdb file.
		 * @return Returns the file.
		 */
		public String getFile(){
			return file;
		}
		
		/**
		 * Sets the filepath of the pdb file.
		 * @param file The filepath to set.
		 */
		public void setFile(String file){
			this.file = file;
		}
		
		/**
		 * Returns the pdb code of the pdb file
		 * @return Returns the pdbname.
		 */
		public String getName(){
			return pdbname;
		}
	}

