package gui;

import javax.swing.tree.DefaultMutableTreeNode;

public class DefaultMutableTreeNodeKatagory extends DefaultMutableTreeNode{
	public int is_value = 0;
	public String name;
	public int ideal_value = 0;

	/**
	 * Constructs a node object for a category in the membrane model tree.
	 * @param name name of the node.
	 * @param percent percent value of the protein, which should be first added to the component.
	 */
	public DefaultMutableTreeNodeKatagory(String name, int percent){
		this.name = name;
		this.is_value = percent;
		this.setUserObject(name);
	}
	
	/**
	 * Adds to the current percent value of the category an additional value (for example when adding a new protein to the component).
	 * @param add new percent value to add.
	 */
	public void update_is_value(int add){
		is_value = is_value + add;
	}
	
	/**
	 * Returns the is_value of the category node.
	 * @return Returns the is_value.
	 */
	public int getIs_value(){
		return is_value;
		
	}
	
	/**
	 * Sets the is_value of the category node.
	 * @param is_value The is_value to set.
	 */
	public void setIs_value(int is_value){
		this.is_value = is_value;
	}

	/**
	 * Returns the node name.
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	
	}

	/**
	 * Sets the node name.
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Returns the ideal value of the kategory. 
	 * @return Returns the ideal_value.
	 */
	public int getIdeal_value() {
		return ideal_value;
	}

	/**
	 * Sets the ideal value of the kategory node.
	 * @param ideal_value The ideal_value to set.
	 */
	public void setIdeal_value(int ideal_value) {
		this.ideal_value = ideal_value;
	}

}
