package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.util.Vector;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import membranModel.MembranModelSingleton;

import protein.Protein;

public class JProperties extends JPanel  {

	public JScrollPane sp;
	public JTextArea information;
	/**
	 * Creates the panel with the content in the Properties tab.
	 * It shows some additional information about a pdb or component.
	 *
	 */
	public JProperties(){
		BorderLayout layout = new BorderLayout();
		this.setLayout(layout);
		information = new JTextArea();
		information.setFocusable(false);
		sp = new JScrollPane(information);
		this.add(sp,BorderLayout.CENTER );
		information.setBackground(MembranModelSingleton.getInstance().getBackground_color());
	}
	
	/**
	 * Sets the text in the JTextArea of this tab.
	 * @param toprint The text which should be printed in the Area of the JPanel.
	 * 
	 */
	public void setPropertiesText(String toprint) {
		Font title = new Font("Dialog", Font.BOLD ,14);
		Font description = new Font("Dialog", Font.BOLD ,12);
			information.setFont(title);

		information.setText(toprint);

		
	}

}
