/**
 * CVS-informations
 * 
 * $Author: jan $
 * $Date: 2006/05/24 10:25:31 $
 * $Revision: 1.12 $
 * 
 */
package gui;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;

import javax.swing.JPanel;

import org.jmol.adapter.smarter.SmarterJmolAdapter;
import org.jmol.api.JmolAdapter;
import org.jmol.api.JmolStatusListener;
import org.jmol.api.JmolViewer;
import org.jmol.popup.JmolPopup;

import protein.Protein;

/**
 * This class creates a new JPanel with a new JmolViewer located on it.
 */
public class JmolPdbPreview extends JPanel implements JmolStatusListener {
	
	final Dimension currentSize = new Dimension();

	final Rectangle rectClip = new Rectangle();

	private JPanel frame;

	static String EMPTYCMD = "zap; set echo top center; font echo 22; color echo white;echo \"no structure found\";";

	JmolViewer viewer;

	JmolAdapter adapter;

	JmolPopup jmolpopup;

	/**
	 * Creates a new JPanel with a new JmolViewer located on it.
	 * 
	 */
	public JmolPdbPreview() {
		// this(null);
		adapter = new SmarterJmolAdapter(null);
		// TODO: CDK Jmol Adapterklasesn integrieren, nicht im CVS von Jmol
		// und auch nicht in openscice! Im Notfall muss das selber gehackt
		// werden!
		// adapter = new CdkJmolAdapter(null);

		viewer = org.jmol.viewer.Viewer.allocateViewer(this, adapter);
		viewer.setJmolStatusListener(this);
		jmolpopup = JmolPopup.newJmolPopup(viewer);
	}

	/**
	 * Creates a new JmolViewer located on the given JPanel.
	 * 
	 * @param frame
	 *            JPanel on which the the new viewer has been added.
	 */
	public JmolPdbPreview(JPanel frame) { // JFrame frame
		super();
		frame = this; // auskommentieren
		adapter = new SmarterJmolAdapter(null);
		// TODO: CDK Jmol Adapterklasesn integrieren, nicht im CVS von Jmol
		// und auch nicht in openscice! Im Notfall muss das selber gehackt
		// werden!
		// adapter = new CdkJmolAdapter(null);

		viewer = org.jmol.viewer.Viewer.allocateViewer(this, adapter);
		viewer.setJmolStatusListener(this);
		jmolpopup = JmolPopup.newJmolPopup(viewer);
	}

	/**
	 * Creates a new JmolViewer located on the given JPanel. Too use all
	 * functions of the viewer set restricted mode to false. If restricted is
	 * set to true, then the viewer uses not all JmolFeatures! It needs a lipid
	 * also (in pdb format), to generate a pdb membrane later.
	 * 
	 * @param frame
	 *            The JPanel the viewer is located on.
	 * @param lipid
	 *            The used lipid
	 * @param restricted
	 *            Use restricted mode.
	 */
	public JmolPdbPreview(JPanel frame, Protein lipid, boolean restricted) { // JFrame
																				// frame
		super();
		frame = this;
		this.frame = frame;
		adapter = new SmarterJmolAdapter(null);
		// TODO: CDK Jmol Adapterklasesn integrieren, nicht im CVS von Jmol
		// und auch nicht in openscice! Im Notfall muss das selber gehackt
		// werden!
		// adapter = new CdkJmolAdapter(null);

		viewer = org.jmol.viewer.Viewer.allocateViewer(this, adapter,
				restricted, frame, lipid);

		viewer.setJmolStatusListener(this);
		jmolpopup = JmolPopup.newJmolPopup(viewer, restricted);

	}

	/**
	 * Creates a new JmolViewer located on the given JPanel. Too use all
	 * functions of the viewer set restricted mode to false. If restricted is
	 * set to true, then the viewer uses not all JmolFeatures! It needs a lipid
	 * also (in pdb format), to generate a pdb membrane later.
	 * 
	 * @param frame
	 *            The JPanel the viewer is located on.
	 * @param lipid
	 *            The used lipid.
	 * @param restricted
	 *            Use restricted mode.
	 * @param preview
	 *            A JPreview Ojbect to locate it inside the viewer himself to
	 *            communicate with the JPreview class.
	 */
	public JmolPdbPreview(JPanel frame, Protein lipid, boolean restricted,
			JPreview preview) { // JFrame frame
		super();
		frame = this;
		this.frame = frame;
		adapter = new SmarterJmolAdapter(null);
		// TODO: CDK Jmol Adapterklasesn integrieren, nicht im CVS von Jmol
		// und auch nicht in openscice! Im Notfall muss das selber gehackt
		// werden!
		// adapter = new CdkJmolAdapter(null);

		viewer = org.jmol.viewer.Viewer.allocateViewer(this, adapter,
				restricted, frame, lipid);

		viewer.setJmolStatusListener(this);
		viewer.setJPreview(preview);
		jmolpopup = JmolPopup.newJmolPopup(viewer, restricted);

	}

	/**
	 * Returns the used frame
	 * 
	 * @return JPanel
	 */
	public JPanel getFrame() {
		return frame;
	}

	/**
	 * @param frame
	 *            The frame to set.
	 */
	public void setFrame(JPanel frame) {
		this.frame = frame;
	}

	/** ! Not longer used, will be deleted in next release ! */
	public void setStructure() {
		viewer.openFile("JoboProtein.pdb");
		jmolpopup.updateComputedMenus();
	}

	/**
	 * returns the JmolViewer
	 * 
	 * @return the viewer
	 */
	public JmolViewer getViewer() {
		return viewer;
	}

	/**
	 * paint Jmol
	 * 
	 * @param g
	 *            Graphics g
	 */
	public void paint(Graphics g) {
		getSize(currentSize);
		g.getClipBounds(rectClip);
		viewer.renderScreenImage(g, currentSize, rectClip);

	}

	/**
	 * Reset the Jmol display.
	 * 
	 */
	public void reset() {
		viewer.homePosition();

	}

	public void notifyFileNotLoaded(String fullPathName, String errorMsg) {
	}

	/**
	 * Sets the PopupMenu of jmol on the given x and y position
	 * 
	 * @param x
	 *            X position.
	 * @param y
	 *            Y porition.
	 */
	public void handlePopupMenu(int x, int y) {
		// logger.finest("handlePopupMenu");
		// viewer.popupMenu(e.getX(),e.getY());
		jmolpopup.show(x, y);

	}

	// ---> No javadoc on empty classes
	public void notifyFileLoaded(String fullPathName, String fileName,
			String modelName, Object clientFile, String errorMessage) {
		// TODO

	}

	public void setStatusMessage(String statusMessage) {
		// TODO

	}

	public void scriptEcho(String strEcho) {
		// TODO

	}

	public void scriptStatus(String strStatus) {
		// TODO

	}

	public void notifyScriptTermination(String statusMessage, int msWalltime) {
		// TODO

	}

	public void notifyMeasurementsChanged() {
		// TODO

	}

	public void notifyFrameChanged(int frameNo) {
		// TODO

	}

	public void notifyAtomPicked(int atomIndex, String strInfo) {
		// TODO

	}

	public void showUrl(String url) {
		// TODO

	}

	public void showConsole(boolean showConsole) {
		// TODO

	}
}
