/**
 * CVS-informations
 * 
 * $Author: robert $
 * $Date: 2006/05/18 12:39:15 $
 * $Revision: 1.17 $
 * 
 */
package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.util.HashMap;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;

import membranModel.MembranModel;
import membranModel.MembranModelSingleton;
import msg.ProteinElement;
import msg.ProteinMatrix;

public class Msg_panel extends JPanel implements ActionListener {

	JScrollPane scroll;
	JPanel panel;
	
	// size of membrane is editable
	int mHeight = 40;
	int mWidth = 60;	
	int wWidth = 600;
	int wHeight = 408;
	int pWidth;
	int pHeight;
	int mOffsetX, mOffsetY;

	int proteinElementNumber = 0;
	ProteinMatrix proteinMatrix;
	ProteinElement clickedProtein;
	boolean clickedProteinSet = false;
	
	Vector vectorE = new Vector();
	Vector proteins = new Vector();
	
	JButton generateNew, rotateProtein, blub, zoomIn, zoomOut, donen;
	
	String generateNewText = "Generate New";
	String rotateProteinText = "Rotate Protein";
	String blubText = "Reset Zoom";
	String zoomInText = "Zoom in";
	String zoomOutText = "Zoom out";	
	String donenText = "Done";

	/**
	 * Creates the panel with the content for the MembranPreview tab.
	 *
	 */
	public Msg_panel() {
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc;

		this.setLayout(gbl);

		gbc = makegbc(0,0,7,1);
		gbc.weightx = mWidth;
		gbc.weighty = mHeight;
		gbc.fill = GridBagConstraints.BOTH;
		JPanel panel = new JPanel(new BorderLayout());
		panel.setBackground(Color.BLACK);
		panel.addComponentListener(new ComponentListener() {		
			public void componentHidden(ComponentEvent arg0) {}		
			public void componentShown(ComponentEvent arg0) {}		
			public void componentMoved(ComponentEvent arg0) {}		
			public void componentResized(ComponentEvent arg0) {
				proteinMatrix.changeResize();
			}});
		proteinMatrix = new ProteinMatrix(this, wWidth, wHeight);
		scroll = new JScrollPane();
		scroll.setViewportView(proteinMatrix);		
		scroll.setPreferredSize(new Dimension(wWidth,wHeight));
		panel.add(scroll, BorderLayout.CENTER);
		gbl.setConstraints(panel,gbc);
		this.add(panel);

		gbc = makegbc(0, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		generateNew = new JButton(generateNewText);
		//generateNew.setBackground(Color.black);
		//generateNew.setForeground(Color.white);
		//generateNew.setBorderPainted(false);
		generateNew.addActionListener(this);
		gbl.setConstraints(generateNew, gbc);
		this.add(generateNew);

		gbc = makegbc(1, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		zoomIn = new JButton(zoomInText);
		//zoomIn.setBackground(Color.black);
		//zoomIn.setForeground(Color.white);
		//zoomIn.setBorderPainted(false);
		zoomIn.addActionListener(this);
		gbl.setConstraints(zoomIn, gbc);
		this.add(zoomIn);
		
		gbc = makegbc(2, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		blub = new JButton(blubText);
		//blub.setBackground(Color.black);
		//blub.setForeground(Color.white);
		//blub.setBorderPainted(false);
		blub.addActionListener(this);
		gbl.setConstraints(blub, gbc);
		this.add(blub);

		gbc = makegbc(3, 1, 1, 1);
		gbc.weightx = 10;
		gbc.weighty = 1;
		gbc.fill = GridBagConstraints.NONE;
		zoomOut = new JButton(zoomOutText);
		//zoomOut.setBackground(Color.black);
		//zoomOut.setForeground(Color.white);
		//zoomOut.setBorderPainted(false);
		zoomOut.addActionListener(this);
		gbl.setConstraints(zoomOut, gbc);
		this.add(zoomOut);
	}

	/**
	 * Generates the GridBagConstraints for the GridBagLayout.
	 * 
	 * @param x int (column index)
	 * @param y int (row index)
	 * @param width int
	 * @param height int
	 * @return GridBagConstraints
	 */
	private GridBagConstraints makegbc(int x, int y, int width, int height) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.insets = new Insets(0, 0, 0, 0);
		return gbc;
	}

	/**
	 * Adds a new ProteinElement to the Vector of ProteinElements
	 * 
	 * @param neuer ProteinElement
	 */
	public void addProteinToVector(ProteinElement neuer) {
		vectorE.addElement(neuer);
	}

	/**
	 * Get the ProteinElement from the vector of all ProteinElements at the given index.
	 *  
	 * @param index int
	 * @return ProteinElement
	 */
	public ProteinElement getProteinFromVector(int index) {
		return (ProteinElement) vectorE.get(index);
	}

	/**
	 * Set the number of Proteins.
	 *
	 */
	public void setProteinElementNumber_() {
		for (int i = 0; i < proteins.size(); i++) {
			proteinElementNumber += ((Integer) ((HashMap) proteins.get(i))
					.get("quantity")).intValue();
		}
	}

	/**
	 * Performs the action events. 
	 * Mainly for the buttons in the MembranPreview tab.
	 * 
	 * @param event ActionEvent
	 */
	public void actionPerformed(ActionEvent event) {
		String cmd = event.getActionCommand();

		if (cmd.equals(generateNewText)) {
			deleteAll();
			MembranModel model = MembranModelSingleton.getInstance();
			model.complete_scaling_proteins();
			
			proteinMatrix.generateNew();
			((JWorkPanel) SwingUtilities.getAncestorNamed("workpanel",
					this)).main.setGenerate(true);
		}

		if (cmd.equals(rotateProteinText)) {
			if (!clickedProteinSet || !clickedProtein.rotateProteinElement()) {
				//System.out.println("ERROR: rotate not possible !");
			} else {
				//System.out.println("rotate done");
			}
		}

		if (cmd.equals(blubText)) {
			proteinMatrix.changeZoomDefault();
		}

		if (cmd.equals(zoomInText)) {
			proteinMatrix.changeZoomIn();
		}
		
		if (cmd.equals(zoomOutText)) {
			proteinMatrix.changeZoomOut();
		}
		
		if (cmd.equals(donenText)) {
			proteinMatrix.saveCurrentStatus();
		}
	}
	
	/**
	 * Deletes all elements of the vector of ProteinElements and the ProteinMatrix object. 
	 *
	 */
	public void deleteAll() {
		getVectorE().removeAllElements();
		proteinMatrix.removeAll();
		proteinMatrix.clearCords();
	}

	/**
	 * @return Returns the pHeight.
	 */
	public int getPHeight() {
		return pHeight;
	}

	/**
	 * @param height The pHeight to set.
	 */
	public void setPHeight(int height) {
		pHeight = height;
	}

	/**
	 * @return Returns the pWidth.
	 */
	public int getPWidth() {
		return pWidth;
	}

	/**
	 * @param width The pWidth to set.
	 */
	public void setPWidth(int width) {
		pWidth = width;
	}

	/**
	 * @return Returns the generateNew.
	 */
	public JButton getGenerateNew() {
		return generateNew;
	}

	/**
	 * @param generateNew The generateNew to set.
	 */
	public void setGenerateNew(JButton generateNew) {
		this.generateNew = generateNew;
	}

	/**
	 * @return Returns the blub.
	 */
	public JButton getBlub() {
		return blub;
	}

	/**
	 * @param blub The blub to set.
	 */
	public void setBlub(JButton blub) {
		this.blub = blub;
	}

	/**
	 * @return Returns the blubText.
	 */
	public String getBlubText() {
		return blubText;
	}

	/**
	 * @param blubText The blubText to set.
	 */
	public void setBlubText(String blubText) {
		this.blubText = blubText;
	}

	/**
	 * @return Returns the clickedProtein.
	 */
	public ProteinElement getClickedProtein() {
		return clickedProtein;
	}

	/**
	 * @param clickedProtein The clickedProtein to set.
	 */
	public void setClickedProtein(ProteinElement clickedProtein) {
		this.clickedProtein = clickedProtein;
	}

	/**
	 * @return Returns the clickedProteinSet.
	 */
	public boolean isClickedProteinSet() {
		return clickedProteinSet;
	}

	/**
	 * @param clickedProteinSet The clickedProteinSet to set.
	 */
	public void setClickedProteinSet(boolean clickedProteinSet) {
		this.clickedProteinSet = clickedProteinSet;
	}

	/**
	 * @return Returns the donen.
	 */
	public JButton getDonen() {
		return donen;
	}

	/**
	 * @param donen The donen to set.
	 */
	public void setDonen(JButton donen) {
		this.donen = donen;
	}

	/**
	 * @return Returns the donenText.
	 */
	public String getDonenText() {
		return donenText;
	}

	/**
	 * @param donenText The donenText to set.
	 */
	public void setDonenText(String donenText) {
		this.donenText = donenText;
	}

	/**
	 * @return Returns the generateNewText.
	 */
	public String getGenerateNewText() {
		return generateNewText;
	}

	/**
	 * @param generateNewText The generateNewText to set.
	 */
	public void setGenerateNewText(String generateNewText) {
		this.generateNewText = generateNewText;
	}

	/**
	 * @return Returns the mHeight.
	 */
	public int getMHeight() {
		return mHeight;
	}

	/**
	 * @param height The mHeight to set.
	 */
	public void setMHeight(int height) {
		mHeight = height;
	}

	/**
	 * @return Returns the mOffsetX.
	 */
	public int getMOffsetX() {
		return mOffsetX;
	}

	/**
	 * @param offsetX The mOffsetX to set.
	 */
	public void setMOffsetX(int offsetX) {
		mOffsetX = offsetX;
	}

	/**
	 * @return Returns the mOffsetY.
	 */
	public int getMOffsetY() {
		return mOffsetY;
	}

	/**
	 * @param offsetY The mOffsetY to set.
	 */
	public void setMOffsetY(int offsetY) {
		mOffsetY = offsetY;
	}

	/**
	 * @return Returns the mWidth.
	 */
	public int getMWidth() {
		return mWidth;
	}

	/**
	 * @param width The mWidth to set.
	 */
	public void setMWidth(int width) {
		mWidth = width;
	}

	/**
	 * @return Returns the panel.
	 */
	public JPanel getPanel() {
		return panel;
	}

	/**
	 * @param panel The panel to set.
	 */
	public void setPanel(JPanel panel) {
		this.panel = panel;
	}

	/**
	 * @return Returns the proteinElementNumber.
	 */
	public int getProteinElementNumber() {
		return proteinElementNumber;
	}

	/**
	 * @param proteinElementNumber The proteinElementNumber to set.
	 */
	public void setProteinElementNumber(int proteinElementNumber) {
		this.proteinElementNumber = proteinElementNumber;
	}

	/**
	 * @return Returns the proteinMatrix.
	 */
	public ProteinMatrix getProteinMatrix() {
		return proteinMatrix;
	}

	/**
	 * @param proteinMatrix The proteinMatrix to set.
	 */
	public void setProteinMatrix(ProteinMatrix proteinMatrix) {
		this.proteinMatrix = proteinMatrix;
	}

	/**
	 * @return Returns the proteins.
	 */
	public Vector getProteins() {
		return proteins;
	}

	/**
	 * @param proteins The proteins to set.
	 */
	public void setProteins(Vector proteins) {
		this.proteins = proteins;
	}

	/**
	 * @return Returns the rotateProtein.
	 */
	public JButton getRotateProtein() {
		return rotateProtein;
	}

	/**
	 * @param rotateProtein The rotateProtein to set.
	 */
	public void setRotateProtein(JButton rotateProtein) {
		this.rotateProtein = rotateProtein;
	}

	/**
	 * @return Returns the rotateProteinText.
	 */
	public String getRotateProteinText() {
		return rotateProteinText;
	}

	/**
	 * @param rotateProteinText The rotateProteinText to set.
	 */
	public void setRotateProteinText(String rotateProteinText) {
		this.rotateProteinText = rotateProteinText;
	}

	/**
	 * @return Returns the scroll.
	 */
	public JScrollPane getScroll() {
		return scroll;
	}

	/**
	 * @param scroll The scroll to set.
	 */
	public void setScroll(JScrollPane scroll) {
		this.scroll = scroll;
	}

	/**
	 * @return Returns the vectorE.
	 */
	public Vector getVectorE() {
		return vectorE;
	}

	/**
	 * @param vectorE The vectorE to set.
	 */
	public void setVectorE(Vector vectorE) {
		this.vectorE = vectorE;
	}

	/**
	 * @return Returns the wHeight.
	 */
	public int getWHeight() {
		return wHeight;
	}

	/**
	 * @param height The wHeight to set.
	 */
	public void setWHeight(int height) {
		wHeight = height;
	}

	/**
	 * @return Returns the wWidth.
	 */
	public int getWWidth() {
		return wWidth;
	}

	/**
	 * @param width The wWidth to set.
	 */
	public void setWWidth(int width) {
		wWidth = width;
	}

	/**
	 * @return Returns the zoomIn.
	 */
	public JButton getZoomIn() {
		return zoomIn;
	}

	/**
	 * @param zoomIn The zoomIn to set.
	 */
	public void setZoomIn(JButton zoomIn) {
		this.zoomIn = zoomIn;
	}

	/**
	 * @return Returns the zoomInText.
	 */
	public String getZoomInText() {
		return zoomInText;
	}

	/**
	 * @param zoomInText The zoomInText to set.
	 */
	public void setZoomInText(String zoomInText) {
		this.zoomInText = zoomInText;
	}

	/**
	 * @return Returns the zoomOut.
	 */
	public JButton getZoomOut() {
		return zoomOut;
	}

	/**
	 * @param zoomOut The zoomOut to set.
	 */
	public void setZoomOut(JButton zoomOut) {
		this.zoomOut = zoomOut;
	}

	/**
	 * @return Returns the zoomOutText.
	 */
	public String getZoomOutText() {
		return zoomOutText;
	}

	/**
	 * @param zoomOutText The zoomOutText to set.
	 */
	public void setZoomOutText(String zoomOutText) {
		this.zoomOutText = zoomOutText;
	}
}
