package gui;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class NewProteinDialog extends JDialog implements ActionListener {

		public JTextField description, name;
		public boolean returnValue;
		/**
		 * Builds up a JDialog for creating a new protein database.
		 * @param main Main
		 */
		public NewProteinDialog(Main main){
			this.setTitle("New protein database");
			this.requestFocus(true);
			this.setSize(320, 140);
			this.setLocationRelativeTo(main);
			this.setModal(true);

			JTextArea nameOrder = new JTextArea("Please enter a name for the new protein database");
			nameOrder.setBackground(null);
			nameOrder.setFocusable(false);
			nameOrder.setFont(new Font("Dialog", Font.BOLD ,12));
			name = new JTextField(1);
			name.setBorder(BorderFactory.createTitledBorder(""));
			
			Box namebox = new Box(BoxLayout.X_AXIS);
			namebox.add(Box.createHorizontalStrut(15));
			namebox.add(name);
			namebox.add(Box.createHorizontalStrut(15));

			Box nameorderbox = new Box(BoxLayout.X_AXIS);
			nameorderbox.add(Box.createHorizontalStrut(15));
			nameorderbox.add(nameOrder);
			nameorderbox.add(Box.createHorizontalStrut(15));
			
			JButton okey = new JButton("OK");
			JButton cancel = new JButton("Cancel");
			okey.addActionListener(this);
			cancel.addActionListener(this);
			
			//adding the buttons to the bottonbox
			Box buttonbox = new Box(BoxLayout.X_AXIS);
			buttonbox.add(Box.createVerticalStrut(30));
			buttonbox.add(okey);
			buttonbox.add(Box.createVerticalStrut(20));
			buttonbox.add(cancel);
			buttonbox.add(Box.createVerticalStrut(30));

			//adding the topbox and the bottumbox to the mainbox
			Box mainbox = new Box(BoxLayout.Y_AXIS);
			mainbox.add(Box.createVerticalStrut(10));
			mainbox.add(nameorderbox);
			mainbox.add(Box.createVerticalStrut(5));
			mainbox.add(namebox);
			mainbox.add(Box.createVerticalStrut(10));
			mainbox.add(buttonbox);
			mainbox.add(Box.createVerticalStrut(20));
			name.requestFocus(true);
			getContentPane().add(mainbox);


			show();

		
			
		}
		
		/**
		 * Performs the action events for the JDialog (mainly the ok and cancel button).
		 * 	 
		 * @param arg0 ActionEvent
		 */
		public void actionPerformed(ActionEvent arg0) {
			String actionCommand = arg0.getActionCommand();
			if(actionCommand.equals("OK")){
				if(!(name.getText().equals(""))){
					returnValue = true;
					dispose();
					
				}
				else{
					JOptionPane.showMessageDialog(null,"Please enter a name for the new Membrane Model!" );
					name.setFocusable(true);
				}
			}
			if(actionCommand.equals("Cancel")){
				returnValue = false;
				dispose();
			}		
			
		}
/**
 * Returns the name of the protein database.
 * @return name String
 */
		public String getName() {
			return name.getText();
		}
/**
 * Returns the return value of the JDialog.
 * @return Returns the returnValue.
 */
		public boolean getReturnValue() {
			return returnValue;
		}




	}
