package gui;

import java.io.File;

import javax.swing.filechooser.FileFilter;

class PDBFileFilter extends javax.swing.filechooser.FileFilter {
	/**
	 * Checks the file for correct ending.
	 * @param f file to check 
	 * @return boolean (true if f is directory or ends with pdb)
	 */
    public boolean accept(File f) {
        return f.isDirectory() || f.getName().toLowerCase().endsWith(".pdb");
    }
    
    /**
     * Returns the description of the file.
     * @return String 
     */
    public String getDescription() {
        return "Protein Databank Format(.pdb)";
    }
}