package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JPopupMenu;

import membranModel.MembranModelSingleton;

public class Statistic extends JPanel {

	private JTextArea legend;
//	private int width, hohe;
	
	
	private JTree membranTree;
	private int width, height;
	private Vector first_graph;
	private int restKategorie;
	private int lipide;
	public String show ;
	private JScrollPane sp;
	/**
	 * Creates the panel with the content in the Statistic tab.
	 * It shows the distribution of the components in the membrane.
	 *
	 * @param membranTree Membrane Model Tree
	 */
	public Statistic(JTree membranTree) {
		this.membranTree = membranTree;
		this.setBackground(Color.white);
		legend = new JTextArea("test");
		legend.setFocusable(false);
		legend.setBackground(new Color(240, 255, 200));
		sp = new JScrollPane(legend);
	//	this.add(sp, new BorderLayout().CENTER);
		setBackground(MembranModelSingleton.getInstance().getBackground_color());
		//this.addMouseMotionListener(this);

	}
/**
 * Paints the distribution cake.
 */
	public void paint(Graphics g) {
		super.paint(g);
		g.setFont(new Font("Dialog", Font.BOLD ,14));
		g.drawString("                     The circle-diagram shows the ratio of the components in ", 10, 15);		
		g.drawString("                     comparison to the lipids on the surface of the membrane.", 10, 32);		
					
		
		
		first_graph = new Vector();
		lipide = 100;
		height = (int) this.getSize().getHeight();
		width = (int) this.getSize().getWidth();
		Color[] colors = {new Color(25,25,112),
				  new Color(75,0,75),
				  new Color(1,1,1),
				  new Color(139,69,19),
				  new Color(110,139,61),
				  new Color(139,139,122),
				  new Color(65,105,225),
				  new Color(139,134,78),
				  new Color(139,90,0),
				  new Color(218,165,32)
				  };
		

		int runner = 0;
		int breite = width - 40;
		int hoehe = height / 4;
		
	    int i_variable = 0;
	    int currdeg = 0;
		
	    int pie_size = ((width-170) > (height-75))?((height-75)):((width-170));

	    int pane_size = pie_size; 
		g.setColor(new Color(189,189,189));
		g.fillArc(35, 55, pie_size, pie_size, 0, 360);	 
		g.setColor(Color.black);

		g.drawRect(2,43, breite+30, pie_size+15);
		g.setColor(new Color(123,104,238));		
		g.fillArc(10, 45, pie_size, pie_size, 0, 360);	
		//g.drawRect(20, height / 6, width - 40, height / 4);
		sp.setLocation(20, 7 * height / 12);
		sp.setSize(new Dimension(width - 40, height / 4));
		legend.setSize(new Dimension(width - 40, height / 4));
		legend.setBackground(null);
		//g.drawRect(20, 7 * height / 12, width - 40, height / 4);
		DefaultMutableTreeNode root = (DefaultMutableTreeNode) membranTree
				.getModel().getRoot();
		int currentX= 20;
		int zahl =1;
		int y_position = 65;
		g.setFont(new Font("Dialog", Font.BOLD ,14));
		int tmp_number = 360;
		g.setColor(Color.black);
		g.drawString("Legend", width-150, y_position);
		g.drawLine(width-150, y_position+3, width-150+53, y_position+3);
		y_position+=24;
		for (int i = 0; i < 3; i++) {
			// Rezeptor, Ionenkanal, usw.
			DefaultMutableTreeNode kategorie = (DefaultMutableTreeNode) root
					.getChildAt(i);
			for (int j = 0; j < kategorie.getChildCount(); j++) {
				// Subkategorien von Rezeptor....
				Color newColor = colors[runner];
				g.setColor(newColor);

				DefaultMutableTreeNodeKatagory subkategorie = (DefaultMutableTreeNodeKatagory) kategorie
						.getChildAt(j);
				int percent = subkategorie.getIs_value();
				if (percent != 0) {
					int deg = ((percent * 360)/ 100);
					int katBreite = breite * percent /100;
					lipide = lipide - percent;
					//g.fillRect(currentX, height / 6, katBreite, height / 4);
//					subkategorie.setPositions(currentX, currentX+katBreite );
					//g.setColor(Color.BLACK);
					g.setFont(new Font("Dialog", Font.BOLD ,14));
					//g.drawString(""+(zahl), (currentX+(katBreite)/2)-5, ((2*height/6)-7));
					tmp_number -=deg;
					// draw arc
					//g.fillArc(10,10, pie_size, pie_size, currdeg, deg); //deg + currdeg);
					g.fillArc(10,45, pie_size, pie_size, tmp_number,deg); //deg + currdeg);
					
					

					// draw legend

					String text = (zahl)+": "+subkategorie.getName()+" "+percent+"%";
					g.drawString(text, width-150, y_position);
					show = show +(zahl)+": "+subkategorie.getName()+" "+percent+"%\n";
	
					first_graph.addElement(subkategorie);
					y_position+=15;
					
					
					// determine value
					//System.out.println("Zahl"+zahl);
					int[] koordinates = get_value(pie_size, pane_size, currdeg, percent, 1, deg, 100, 170, 14, 2);

					// draw value

					g.setColor(Color.WHITE);
					g.drawString(zahl+"", koordinates[0], koordinates[1]+35);
					//g.drawString("t", koordinates[0], pie_size/2+10);

					currentX = currentX + katBreite;

					if (runner < (colors.length-1)) {
						runner++;
					} else {
						runner = 0;
					}
					i_variable++;
					currdeg += deg;
					zahl++;
				}

			}

		}

		if (runner > colors.length-1){
			runner = 0;
		}		
		Color newColor = colors[runner];
		g.setColor(newColor);
		restKategorie = currentX;
//		g.fillRect(currentX, height / 6, width-20-currentX, height / 4);
		g.setColor(new Color(123,104,238));

		//g.drawString(""+(zahl), currentX-5+((width-20-currentX)/2), (2*height / 6)-7 );
		int deg = lipide * 360 /100;
//		g.fillArc(10, 10, pie_size, pie_size, currdeg, deg);
		String text = (zahl)+": Lipide "+lipide+"%";
		g.drawString(text, width-150, y_position);

		show = show +(zahl)+": Lipide "+lipide+"%";
		legend.setFont(new Font("Dialog", Font.BOLD ,14));
		legend.setText(show);
		int[] koordinates = get_value(pie_size, pane_size, currdeg, lipide, 1, deg, 100, 170, 14, 2);
		g.setColor(Color.white);
		// draw value

		g.drawString(zahl+"", koordinates[0], koordinates[1]);


	}
	
	private int[] get_value(int pie_size, int pane_size, int currdeg, int percent, int show_percent, int deg, int total, int fw, int fh, int float_digits) {
		double valdeg = currdeg + (deg / 2);
		double currad = valdeg  * Math.PI / 180;
	    int y = (int) ((Math.sin(currad)) * (pie_size / 2.2) +  pie_size/2+10);
		int x = (int) ((Math.cos((-1)*currad)) * (pie_size / 2.2) + pie_size/2+10);
		if(valdeg<90 ){
			y = y + 7;
			x = x - 2;
		}else if(valdeg<180){
			y = y + 3;
			x = x - 4;
		}else if(valdeg<270){
			x = x+6;
			y = y+28;
		}else { //270-360
			y= y+40;
			x= x+8;
		}
	    int[] array = {x,y};
	    return (array);

	}
	
	
	
}