package gui.dragndrop;

import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

public class TreeDragGestureListener implements DragGestureListener {
/**
 * Starts dragging a transferable node if it is possible.
 * @param dragGestureEvent DragGestureEvent
 */
    public void dragGestureRecognized(DragGestureEvent dragGestureEvent) {
    	JTree dragTree = (JTree) dragGestureEvent.getComponent();
    	TreePath path = dragTree.getSelectionPath();
      if (path == null) {
        // Nothing selected, nothing to drag
        dragTree.getToolkit().beep();
      } else {
        DefaultMutableTreeNode selection = (DefaultMutableTreeNode) path
            .getLastPathComponent();
        if (selection.isLeaf()) {
          TransferableTreeNode node = new TransferableTreeNode(selection);
          dragGestureEvent.startDrag(DragSource.DefaultCopyDrop,
                  node, new MyDragSourceListener());

        } else {
          dragTree.getToolkit().beep();
        }
      }
    }
}
