package jmolOutsideApplicationTest;
/* $RCSfile: Integration2.java,v $
 * $Author: bsommer $
 * $Date: 2006/02/01 10:50:41 $
 * $Revision: 1.1 $
 *
 * Copyright (C) 2000-2005  The Jmol Development Team
 *
 * Contact: jmol-developers@lists.sf.net
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307  USA.
 */

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import org.jmol.adapter.smarter.SmarterJmolAdapter;
import org.jmol.api.JmolAdapter;
import org.jmol.api.JmolSimpleViewer;
import org.jmol.api.JmolStatusListener;

/**
 * A example of integrating the Jmol viewer into a java application.
 *
 * <p>I compiled/ran this code directly in the examples directory by doing:
 * <pre>
 * javac -classpath ../Jmol.jar Integration.java
 * java -cp .:../Jmol.jar Integration
 * </pre>
 *
 * @author Miguel <miguel@jmol.org>
 */

public class Integration2{

  public static void main(String[] argv) {
    JFrame frame = new JFrame("Hello");
    OuterIntegration jmol = new OuterIntegration(frame);
    Container contentPane = frame.getContentPane();

    frame.add(jmol);
    frame.setSize(300, 300);
    frame.setVisible(true);
    
    final String peter = 
      "3\n" +
      "water\n" +
      "O  0.0 0.0 0.0\n" +
      "H  0.76923955 -0.59357141 0.0\n" +
      "H -0.76923955 -0.59357141 0.0\n";
    
    final String jobo =
      "4\n"+
      "jobo\n"+
      "H 1.0 0.0 0.0\n"+
      "P 0.0 0.0 1.0\n"+
      "P 0.0 0.0 2.0\n"+
      "P 0.0 0.0 3.0\n";
    
    //jmol.setStructure();
    //jmol.getViewer().openFile("JoboProtein.pdb");
    jmol.getViewer().openStringInline(peter);
    

    
    
    
    //jmol.getViewer().openFile("JoboProtein.pdb");
    jmol.getViewer().openStringInline(jobo);





  }

  public void notifyFileLoaded(String fullPathName, String fileName, String modelName, Object clientFile, String errorMessage) {
    // TODO
    
  }

  public void setStatusMessage(String statusMessage) {
    // TODO
    
  }

  public void scriptEcho(String strEcho) {
    // TODO
    
  }

  public void scriptStatus(String strStatus) {
    // TODO
    
  }

  public void notifyScriptTermination(String statusMessage, int msWalltime) {
    // TODO
    
  }

  public void handlePopupMenu(int x, int y) {
    // TODO
    
  }

  public void notifyMeasurementsChanged() {
    // TODO
    
  }

  public void notifyFrameChanged(int frameNo) {
    // TODO
    
  }

  public void notifyAtomPicked(int atomIndex, String strInfo) {
    // TODO
    
  }

  public void showUrl(String url) {
    // TODO
    
  }

  public void showConsole(boolean showConsole) {
    // TODO
    
  }
}
