 /**
 * CVS-informations
 * 
 * $Author: sebastian $
 * $Date: 2006/06/13 15:27:14 $
 * $Revision: 1.4 $
 * 
 */
package membranModel;

/**
 *This class generates an instance of the membrane model. 
 *
 */
public class MembranModelSingleton extends MembranModel{

	private static MembranModel single_membran = null;
	
	protected MembranModelSingleton(){  
	
	}

	/**
	 * If an instance of membrane model does not exist an instance will
	 * be generated. Otherwise the existing instance of the membrane 
	 * model will be returned.
	 * 
	 * @return Membran model
	 */
	public static MembranModel getInstance(){
		if (single_membran == null){
			single_membran = new MembranModelSingleton();
		}
		return single_membran;
	}

	/**
	 * This function replaces the existing 
	 * membrane model with a new one.
	 * @param membran
	 */	
	public static void setInstance(MembranModel membran) {
	single_membran = membran;
	}
}
