package msg;

import gui.Msg_panel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;


public class MatrixProgressBar extends JPanel {

	JProgressBar bar;
	int width         = 250;
	int height        = 50;
	int progBarHeight = 20;
	int labelHeight   = 20;
		
	//######################################################################################
	//##                                 MAIN STUFF                                       ##
	//######################################################################################
	
	/**
	 * Creates a new progress bar.
	 * 
	 * @param alles Msg_panel
	 * @param panel ProteinMatrix
	 * @param proteinNumber int
	 */
	public MatrixProgressBar(Msg_panel alles, ProteinMatrix panel, int proteinNumber) {
		setSize(width,height);
		int pX = (panel.getWidth() > 0) ? (int)((panel.getWidth()-width)/2) : 100;
		int pY = (panel.getHeight() > 0) ? (int)((panel.getHeight()-height)/2) : 100;
		setLocation(pX, pY);
		setBorder(BorderFactory.createLineBorder(Color.BLACK,1));		
		setBackground(Color.GRAY);
		
		JLabel label = new JLabel();
		label.setFont(new Font("",Font.BOLD,12));
		label.setSize(width, labelHeight);
		label.setText("<HTML><CENTER>Generating positions...<CENTER></HTML>");
		label.setForeground(Color.WHITE);
		add(label, BorderLayout.NORTH);
		
		bar = new JProgressBar(0, proteinNumber);
		bar.setBackground(Color.WHITE);
		bar.setStringPainted(true);
		bar.setPreferredSize(new Dimension(width-6, progBarHeight));
		bar.setBorderPainted(true);
		bar.setLocation(0,0);		
		add(bar, BorderLayout.SOUTH);
	}

	/**
	 * @return Returns the progBarHeight.
	 */
	public int getProgBarHeight() {
		return progBarHeight;
	}

	/**
	 * @param progBarHeight The progBarHeight to set.
	 */
	public void setProgBarHeight(int progBarHeight) {
		this.progBarHeight = progBarHeight;
	}

	/**
	 * @return Returns the bar.
	 */
	public JProgressBar getBar() {
		return bar;
	}

	/**
	 * @param bar The bar to set.
	 */
	public void setBar(JProgressBar bar) {
		this.bar = bar;
	}

	/**
	 * @return Returns the height.
	 */
	public int getHeight() {
		return height;
	}

	/**
	 * @param height The height to set.
	 */
	public void setHeight(int height) {
		this.height = height;
	}

	/**
	 * @return Returns the labelHeight.
	 */
	public int getLabelHeight() {
		return labelHeight;
	}

	/**
	 * @param labelHeight The labelHeight to set.
	 */
	public void setLabelHeight(int labelHeight) {
		this.labelHeight = labelHeight;
	}

	/**
	 * @return Returns the width.
	 */
	public int getWidth() {
		return width;
	}

	/**
	 * @param width The width to set.
	 */
	public void setWidth(int width) {
		this.width = width;
	}

}