package pdbParser;

import java.io.File;

/**
 * This class implements a .pdb-FileFilter for a FileChooser
 */
class PDBFileFilter extends javax.swing.filechooser.FileFilter {
   
	
	/** 
	 * This function returns a boolean regarding to the File-format.
	 * If it is a pdb-File the function returns true, otherwise false.
	 * 
	 * @param File f
	 * @param String Directory 
	 */
	public boolean accept(File f) {
        return f.isDirectory() || f.getName().toLowerCase().endsWith(".pdb");
    }
    
	
	/** 
	 * This function returns the description 
	 * for the .pdb-FileFilter.
	 * 
	 */
    public String getDescription() {
        return "Protein Databank Format (.pdb)";
    }
}
